SystemOrganization addCategory: #'Metacello-Platform'!

MetacelloPharoCommonPlatform subclass: #MetacelloPharo20Platform
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Metacello-Platform'!

!MetacelloPharo20Platform classSide methodsFor: 'initialize-release' stamp: 'ChristopheDemarey 4/29/2013 14:22'!
initialize
  self select

! !

!MetacelloPharo20Platform methodsFor: 'file system' stamp: 'ChristopheDemarey 4/29/2013 14:17'!
defaultDirectory
	"Get the image default directory"
	
	^FileLocator imageDirectory asFileReference! !

!MetacelloPharo20Platform methodsFor: 'file system' stamp: 'ChristopheDemarey 4/29/2013 15:14'!
directoryFromPath: adirectoryPath relativeTo: anotherDirectoryPath
	"Get a handle on the following path: anotherDirectoryPath/adirectoryPath"
	^ anotherDirectoryPath resolveString: adirectoryPath! !

!MetacelloPharo20Platform methodsFor: 'github support' stamp: 'ChristopheDemarey 4/29/2013 16:01'!
downloadFile: url to: outputFileName
    "download from <url> into <outputFileName>"

    | in out err proc archive zipfile |
    in := (' -L ' , url) readStream.
    out := FileStream forceNewFileNamed: outputFileName.
    err := FileStream forceNewFileNamed: '/tmp/curl.err'.
    proc := OSProcess thisOSProcess
        forkJob: '/usr/bin/curl'
        arguments:
            {'-L'.
            url}
        environment: nil
        descriptors: (Array with: nil with: out with: err).
    proc ifNil: [ OSProcess noAccessorAvailable ].
    [ proc isRunning ] whileTrue: [ (Delay forMilliseconds: 100) wait ].
    out close.
    err close.
    archive := ZipArchive new.
    zipfile := outputFileName asFileReference.
    zipfile readStreamDo: [ :fileStream | archive readFrom: fileStream ].
    ^ archive
! !

!MetacelloPharo20Platform methodsFor: 'file system' stamp: 'ChristopheDemarey 4/29/2013 15:18'!
ensureDirectoryExists: aDirectoryHandle
	"Ensure the directory exists."

	^ aDirectoryHandle ensureDirectory ; yourself! !

!MetacelloPharo20Platform methodsFor: 'file system' stamp: 'ChristopheDemarey 4/29/2013 15:58'!
fileDirectoryClass
	^FileSystem! !

!MetacelloPharo20Platform methodsFor: 'file system' stamp: 'ChristopheDemarey 4/29/2013 13:16'!
fileHandleOn: aPath
	"Get an handle on a file."

	^ aPath asFileReference! !

!MetacelloPharo20Platform methodsFor: 'system' stamp: 'ChristopheDemarey 4/29/2013 16:20'!
suspendSystemUpdateEventsDuring: aBlock
	"Wraps call to the system evetn manager to tell it that we want to suspend events during execution of aBlock"
	SystemAnnouncer uniqueInstance suspendAllWhile: aBlock! !
MetacelloPharo20Platform initialize!
